* This module deals with the low level action routine

        Section menu
        xdef    word_action
        xdef    cmd_action
        xref    _process_word
        xref    _do_cmd

cregs     REG     d1-d7/a0-a6
buffsize  EQU     58              ;input window buffer size
status_infw EQU   1

sd.clear  EQU     $20
io.edlin  EQU     $04
wm.swinf  EQU     $58             ;set info window wman vector
wm.swlit  EQU     $5c             ;set window to loose item wman vector
wwl_item  EQU     $10             ;loose item number
ww_wstat  EQU     $00             ;pointer to start of status area
ws.avil   EQU     $00             ;status available
ws_litem  EQU     $40             ;start of loose item status area
selectiv  EQU      -1
wm_ldraw  EQU      $2C



word_action
* input a string into a loose item, buffer at a5->inbuf
        lea     inbuf,a5
        move.w  #0,(a5)
        move.w  #0,2(a5)

* set window to loose item
        move.w  wwl_item(a3),d1
        moveq   #0,d2
        jsr     wm.swlit(a2)
        tst.l   d0
        bne.s   wfin_ok
* set item available
        move.w  wwl_item(a3),d3
        move.l  ww_wstat(a4),a1
        move.b  #ws.avil,ws_litem(a1,d3.w)

* clear window
        moveq   #sd.clear,d0
        moveq   #-1,d3
        trap    #3

* set to QDOS string buffer space
        move.l  a5,a1
; io.edlin version (not std method with PTR JOBS but I like it)
        moveq   #io.edlin,d0
        sub.l   d1,d1
        move.w  (a1)+,d1
        move.w  d1,d2
        ext.l   d2
        add.l   d2,a1
        moveq   #-1,d3
        moveq   #buffsize,d2
        trap    #3
        move.b  #0,-1(a1)               ;terminate in a zero
        subq.w  #1,d1
        move.w  d1,(a5)                 ;set length word
        tst.l   d0
        bne.s   wfin_ok

* set window to status info item
        move.w  #status_infw,d1
        moveq   #-1,d2
        jsr     wm.swinf(a2)
        tst.l   d0
        bne.l   wfin_ok
* call the C level action routine
        movem.l cregs,-(sp)
        move.l  a0,-(sp)
        move.l  a5,-(sp)
        jsr     _process_word
        add.l   #4*2,sp
        movem.l (sp)+,cregs
wfin_ok moveq   #0,d4
        tst.l   d0
        rts

* call the C level action routine
cmd_action
        movem.l cregs,-(sp)
        bsr.s   unselect         ;clear loose item
        move.l  a2,-(sp)         ;wman vector
        jsr     _do_cmd
        add.l   #4,sp
        movem.l (sp)+,cregs
        moveq   #0,d4
        tst.l   d0
        rts

unselect
         move.w   wwl_item(a3),d0
         move.b   #ws.avil+1,ws_litem(a1,d0.w)
         moveq    #selectiv,d3
         jsr      wm_ldraw(a2)
         move.w   wwl_item(a3),d0
         move.b   #ws.avil,ws_litem(a1,d0.w)
         rts

* input buffer
inbuf   dcb.b   buffsize+2,0
        end
